'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Burns = function () {
    function Burns() {
        _classCallCheck(this, Burns);

        this.options = {};
        this.events = {};
        this.queuedListeners = {};
    }

    _createClass(Burns, [{
        key: 'configure',
        value: function configure(options) {
            this.options = Object.assign(this.options, options);
            return this;
        }
    }, {
        key: 'register',
        value: function register(events) {
            for (var eventName in events) {
                var listeners = Array.isArray(events[eventName]) ? events[eventName] : [events[eventName]];
                if (this.events[eventName]) {
                    this.events[eventName] = [].concat(_toConsumableArray(this.events[eventName]), _toConsumableArray(listeners));
                } else {
                    this.events[eventName] = listeners;
                }
            }
            return this;
        }
    }, {
        key: 'event',
        value: function event(eventName) {
            var eventData = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            this.queueListeners(eventName, eventData);
        }
    }, {
        key: 'queueListeners',
        value: function queueListeners(eventName, eventData) {
            var _this = this;

            var listeners = this.events[eventName];

            // fallback to default listener
            if (!listeners) {
                if (!(listeners = this.options.defaultListener)) {
                    return;
                }
            }

            listeners = Array.isArray(listeners) ? listeners : [listeners];
            this.queuedListeners[eventName] = [];

            var _loop = function _loop(listener) {
                var handlerClass = new listener();
                var methodName = 'on' + _this.uppercaseWords(eventName);
                var handlerMethod = typeof handlerClass[methodName] === 'function' ? methodName : 'handle';
                var listenerRef = setTimeout(function () {
                    var continuePropagation = handlerClass[handlerMethod](eventData);
                    // stop the next listeners if this one says so
                    if (continuePropagation === false) {
                        _this.dequeueListeners(eventName);
                    }
                }, 0);
                _this.queuedListeners[eventName].push(listenerRef);
            };

            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = listeners[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var listener = _step.value;

                    _loop(listener);
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        }
    }, {
        key: 'dequeueListeners',
        value: function dequeueListeners(eventName) {
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
                for (var _iterator2 = this.queuedListeners[eventName][Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                    var listenerRef = _step2.value;

                    clearTimeout(listenerRef);
                }
            } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }
                } finally {
                    if (_didIteratorError2) {
                        throw _iteratorError2;
                    }
                }
            }
        }
    }, {
        key: 'uppercaseWords',
        value: function uppercaseWords(string) {
            return string.split(/[^a-zA-Z0-9]+/).map(function (word) {
                return word[0].toUpperCase() + word.slice(1);
            }).join('');
        }
    }]);

    return Burns;
}();

module.exports = new Burns();